#!/usr/bin/python
import codecs
import json
import sys
import os

from arabish import transliterate

def alfred_error(e, query):
    message = e.message if hasattr(e, 'message') else e
    return json.dumps({
        'items': [{
            'title': "Error!!! Query: '{0}'".format(query)
            }]
        })

if __name__ == '__main__':
    # Get query
    query = sys.argv[1]
    # Check non-empty input
    if not query:
        # Keep Alfred from removing the placeholder
        time.sleep(2)
        quit()
    # Try connection
    try:
        # Get matches for input
        # sys.stderr.write("query: '{0}'".format(query))
        ret = transliterate(query).encode('utf-8')
        # sys.stderr.write("ret: '{0}'".format(ret))
        print(json.dumps({
        'items': [{
            'title': ret,
            'subtitle': query,
            'arg': ret
            }]
        }))
    except Exception as e:
        # Return error
        print(alfred_error(e, query))
